/*
         _____          ___   __
        |  __ \        | \ \ / /
        | |__) |___  __| |\ V / 
        |  _  // _ \/ _` | > <  
        | | \ \  __/ (_| |/ . \ 
        |_|  \_\___|\__,_/_/ \_\

        A Win32 Game Programming
               Library
                 by
           Dominique Biesmans
     (c) 1998 - all rights reserved
see readme.1st for copyright information

*/

#include "redx.h"

LINK_GUID(GUID_Key,0x55728220,0xD33C,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
LINK_GUID(GUID_SysKeyboard,0x6F1D2B61,0xD5A0,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);

#define FIELD_OFFSET(type, field)    ((LONG)&(((type *)0)->field))

typedef struct myKeydata {
		BYTE key_0;
		BYTE key_1;
		BYTE key_2;
		BYTE key_3;
		BYTE key_4;
		BYTE key_5;
		BYTE key_6;
		BYTE key_7;
		BYTE key_8;
		BYTE key_9;
		BYTE key_10;
		BYTE key_11;
		BYTE key_12;
		BYTE key_13;
		BYTE key_14;
		BYTE key_15;
		BYTE key_16;
		BYTE key_17;
		BYTE key_18;
		BYTE key_19;
		BYTE key_20;
		BYTE key_21;
		BYTE key_22;
		BYTE key_23;
		BYTE key_24;
		BYTE key_25;
		BYTE key_26;
		BYTE key_27;
		BYTE key_28;
		BYTE key_29;
		BYTE key_30;
		BYTE key_31;
		BYTE key_32;
		BYTE key_33;
		BYTE key_34;
		BYTE key_35;
		BYTE key_36;
		BYTE key_37;
		BYTE key_38;
		BYTE key_39;
		BYTE key_40;
		BYTE key_41;
		BYTE key_42;
		BYTE key_43;
		BYTE key_44;
		BYTE key_45;
		BYTE key_46;
		BYTE key_47;
		BYTE key_48;
		BYTE key_49;
		BYTE key_50;
		BYTE key_51;
		BYTE key_52;
		BYTE key_53;
		BYTE key_54;
		BYTE key_55;
		BYTE key_56;
		BYTE key_57;
		BYTE key_58;
		BYTE key_59;
		BYTE key_60;
		BYTE key_61;
		BYTE key_62;
		BYTE key_63;
		BYTE key_64;
		BYTE key_65;
		BYTE key_66;
		BYTE key_67;
		BYTE key_68;
		BYTE key_69;
		BYTE key_70;
		BYTE key_71;
		BYTE key_72;
		BYTE key_73;
		BYTE key_74;
		BYTE key_75;
		BYTE key_76;
		BYTE key_77;
		BYTE key_78;
		BYTE key_79;
		BYTE key_80;
		BYTE key_81;
		BYTE key_82;
		BYTE key_83;
		BYTE key_84;
		BYTE key_85;
		BYTE key_86;
		BYTE key_87;
		BYTE key_88;
		BYTE key_89;
		BYTE key_90;
		BYTE key_91;
		BYTE key_92;
		BYTE key_93;
		BYTE key_94;
		BYTE key_95;
		BYTE key_96;
		BYTE key_97;
		BYTE key_98;
		BYTE key_99;
		BYTE key_100;
		BYTE key_101;
		BYTE key_102;
		BYTE key_103;
		BYTE key_104;
		BYTE key_105;
		BYTE key_106;
		BYTE key_107;
		BYTE key_108;
		BYTE key_109;
		BYTE key_110;
		BYTE key_111;
		BYTE key_112;
		BYTE key_113;
		BYTE key_114;
		BYTE key_115;
		BYTE key_116;
		BYTE key_117;
		BYTE key_118;
		BYTE key_119;
		BYTE key_120;
		BYTE key_121;
		BYTE key_122;
		BYTE key_123;
		BYTE key_124;
		BYTE key_125;
		BYTE key_126;
		BYTE key_127;
		BYTE key_128;
		BYTE key_129;
		BYTE key_130;
		BYTE key_131;
		BYTE key_132;
		BYTE key_133;
		BYTE key_134;
		BYTE key_135;
		BYTE key_136;
		BYTE key_137;
		BYTE key_138;
		BYTE key_139;
		BYTE key_140;
		BYTE key_141;
		BYTE key_142;
		BYTE key_143;
		BYTE key_144;
		BYTE key_145;
		BYTE key_146;
		BYTE key_147;
		BYTE key_148;
		BYTE key_149;
		BYTE key_150;
		BYTE key_151;
		BYTE key_152;
		BYTE key_153;
		BYTE key_154;
		BYTE key_155;
		BYTE key_156;
		BYTE key_157;
		BYTE key_158;
		BYTE key_159;
		BYTE key_160;
		BYTE key_161;
		BYTE key_162;
		BYTE key_163;
		BYTE key_164;
		BYTE key_165;
		BYTE key_166;
		BYTE key_167;
		BYTE key_168;
		BYTE key_169;
		BYTE key_170;
		BYTE key_171;
		BYTE key_172;
		BYTE key_173;
		BYTE key_174;
		BYTE key_175;
		BYTE key_176;
		BYTE key_177;
		BYTE key_178;
		BYTE key_179;
		BYTE key_180;
		BYTE key_181;
		BYTE key_182;
		BYTE key_183;
		BYTE key_184;
		BYTE key_185;
		BYTE key_186;
		BYTE key_187;
		BYTE key_188;
		BYTE key_189;
		BYTE key_190;
		BYTE key_191;
		BYTE key_192;
		BYTE key_193;
		BYTE key_194;
		BYTE key_195;
		BYTE key_196;
		BYTE key_197;
		BYTE key_198;
		BYTE key_199;
		BYTE key_200;
		BYTE key_201;
		BYTE key_202;
		BYTE key_203;
		BYTE key_204;
		BYTE key_205;
		BYTE key_206;
		BYTE key_207;
		BYTE key_208;
		BYTE key_209;
		BYTE key_210;
		BYTE key_211;
		BYTE key_212;
		BYTE key_213;
		BYTE key_214;
		BYTE key_215;
		BYTE key_216;
		BYTE key_217;
		BYTE key_218;
		BYTE key_219;
		BYTE key_220;
		BYTE key_221;
		BYTE key_222;
		BYTE key_223;
		BYTE key_224;
		BYTE key_225;
		BYTE key_226;
		BYTE key_227;
		BYTE key_228;
		BYTE key_229;
		BYTE key_230;
		BYTE key_231;
		BYTE key_232;
		BYTE key_233;
		BYTE key_234;
		BYTE key_235;
		BYTE key_236;
		BYTE key_237;
		BYTE key_238;
		BYTE key_239;
		BYTE key_240;
		BYTE key_241;
		BYTE key_242;
		BYTE key_243;
		BYTE key_244;
		BYTE key_245;
		BYTE key_246;
		BYTE key_247;
		BYTE key_248;
		BYTE key_249;
		BYTE key_250;
		BYTE key_251;
		BYTE key_252;
		BYTE key_253;
		BYTE key_254;
		BYTE key_255;
}MYKEYDATA;

static DIOBJECTDATAFORMAT rgodfKey[] = {
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_0), 2147483660 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_1), 2147483916 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_2), 2147484172 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_3), 2147484428 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_4), 2147484684 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_5), 2147484940 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_6), 2147485196 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_7), 2147485452 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_8), 2147485708 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_9), 2147485964 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_10), 2147486220 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_11), 2147486476 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_12), 2147486732 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_13), 2147486988 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_14), 2147487244 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_15), 2147487500 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_16), 2147487756 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_17), 2147488012 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_18), 2147488268 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_19), 2147488524 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_20), 2147488780 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_21), 2147489036 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_22), 2147489292 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_23), 2147489548 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_24), 2147489804 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_25), 2147490060 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_26), 2147490316 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_27), 2147490572 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_28), 2147490828 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_29), 2147491084 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_30), 2147491340 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_31), 2147491596 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_32), 2147491852 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_33), 2147492108 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_34), 2147492364 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_35), 2147492620 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_36), 2147492876 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_37), 2147493132 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_38), 2147493388 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_39), 2147493644 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_40), 2147493900 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_41), 2147494156 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_42), 2147494412 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_43), 2147494668 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_44), 2147494924 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_45), 2147495180 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_46), 2147495436 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_47), 2147495692 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_48), 2147495948 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_49), 2147496204 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_50), 2147496460 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_51), 2147496716 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_52), 2147496972 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_53), 2147497228 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_54), 2147497484 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_55), 2147497740 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_56), 2147497996 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_57), 2147498252 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_58), 2147498508 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_59), 2147498764 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_60), 2147499020 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_61), 2147499276 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_62), 2147499532 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_63), 2147499788 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_64), 2147500044 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_65), 2147500300 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_66), 2147500556 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_67), 2147500812 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_68), 2147501068 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_69), 2147501324 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_70), 2147501580 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_71), 2147501836 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_72), 2147502092 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_73), 2147502348 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_74), 2147502604 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_75), 2147502860 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_76), 2147503116 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_77), 2147503372 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_78), 2147503628 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_79), 2147503884 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_80), 2147504140 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_81), 2147504396 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_82), 2147504652 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_83), 2147504908 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_84), 2147505164 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_85), 2147505420 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_86), 2147505676 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_87), 2147505932 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_88), 2147506188 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_89), 2147506444 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_90), 2147506700 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_91), 2147506956 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_92), 2147507212 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_93), 2147507468 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_94), 2147507724 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_95), 2147507980 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_96), 2147508236 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_97), 2147508492 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_98), 2147508748 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_99), 2147509004 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_100), 2147509260 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_101), 2147509516 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_102), 2147509772 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_103), 2147510028 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_104), 2147510284 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_105), 2147510540 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_106), 2147510796 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_107), 2147511052 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_108), 2147511308 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_109), 2147511564 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_110), 2147511820 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_111), 2147512076 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_112), 2147512332 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_113), 2147512588 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_114), 2147512844 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_115), 2147513100 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_116), 2147513356 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_117), 2147513612 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_118), 2147513868 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_119), 2147514124 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_120), 2147514380 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_121), 2147514636 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_122), 2147514892 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_123), 2147515148 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_124), 2147515404 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_125), 2147515660 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_126), 2147515916 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_127), 2147516172 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_128), 2147516428 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_129), 2147516684 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_130), 2147516940 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_131), 2147517196 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_132), 2147517452 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_133), 2147517708 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_134), 2147517964 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_135), 2147518220 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_136), 2147518476 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_137), 2147518732 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_138), 2147518988 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_139), 2147519244 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_140), 2147519500 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_141), 2147519756 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_142), 2147520012 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_143), 2147520268 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_144), 2147520524 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_145), 2147520780 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_146), 2147521036 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_147), 2147521292 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_148), 2147521548 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_149), 2147521804 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_150), 2147522060 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_151), 2147522316 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_152), 2147522572 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_153), 2147522828 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_154), 2147523084 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_155), 2147523340 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_156), 2147523596 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_157), 2147523852 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_158), 2147524108 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_159), 2147524364 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_160), 2147524620 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_161), 2147524876 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_162), 2147525132 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_163), 2147525388 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_164), 2147525644 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_165), 2147525900 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_166), 2147526156 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_167), 2147526412 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_168), 2147526668 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_169), 2147526924 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_170), 2147527180 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_171), 2147527436 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_172), 2147527692 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_173), 2147527948 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_174), 2147528204 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_175), 2147528460 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_176), 2147528716 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_177), 2147528972 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_178), 2147529228 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_179), 2147529484 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_180), 2147529740 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_181), 2147529996 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_182), 2147530252 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_183), 2147530508 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_184), 2147530764 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_185), 2147531020 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_186), 2147531276 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_187), 2147531532 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_188), 2147531788 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_189), 2147532044 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_190), 2147532300 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_191), 2147532556 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_192), 2147532812 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_193), 2147533068 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_194), 2147533324 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_195), 2147533580 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_196), 2147533836 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_197), 2147534092 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_198), 2147534348 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_199), 2147534604 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_200), 2147534860 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_201), 2147535116 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_202), 2147535372 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_203), 2147535628 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_204), 2147535884 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_205), 2147536140 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_206), 2147536396 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_207), 2147536652 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_208), 2147536908 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_209), 2147537164 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_210), 2147537420 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_211), 2147537676 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_212), 2147537932 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_213), 2147538188 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_214), 2147538444 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_215), 2147538700 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_216), 2147538956 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_217), 2147539212 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_218), 2147539468 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_219), 2147539724 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_220), 2147539980 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_221), 2147540236 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_222), 2147540492 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_223), 2147540748 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_224), 2147541004 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_225), 2147541260 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_226), 2147541516 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_227), 2147541772 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_228), 2147542028 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_229), 2147542284 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_230), 2147542540 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_231), 2147542796 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_232), 2147543052 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_233), 2147543308 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_234), 2147543564 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_235), 2147543820 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_236), 2147544076 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_237), 2147544332 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_238), 2147544588 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_239), 2147544844 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_240), 2147545100 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_241), 2147545356 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_242), 2147545612 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_243), 2147545868 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_244), 2147546124 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_245), 2147546380 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_246), 2147546636 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_247), 2147546892 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_248), 2147547148 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_249), 2147547404 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_250), 2147547660 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_251), 2147547916 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_252), 2147548172 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_253), 2147548428 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_254), 2147548684 , 0,},
{&GUID_Key, FIELD_OFFSET(MYKEYDATA, key_255), 2147548940 , 0,},
};

#define numObjects (sizeof(rgodfKey) / sizeof(rgodfKey[0]))
const DIDATAFORMAT c_dfDIKeyboard={
        sizeof(DIDATAFORMAT),
        sizeof(DIOBJECTDATAFORMAT),
        DIDF_RELAXIS,
        sizeof(struct myKeydata),
        numObjects,
        rgodfKey};
#undef numObjects

/* todo : put in DX_CONTEXT */
char keyArray[256];

BOOL DX_InitKeyboard(DX_CONTEXT *pdxcContext)
{
    BOOL bReturn=FALSE;
    if (DX_InitInput(pdxcContext))
    {
        pdxcContext->hLastResult = IDirectInput_CreateDevice(pdxcContext->lpDI, &GUID_SysKeyboard,
            &(pdxcContext->lpDIKeyboardDevice), NULL);
        if (pdxcContext->hLastResult==DI_OK)
        {
            pdxcContext->hLastResult = IDirectInputDevice_SetDataFormat(pdxcContext->lpDIKeyboardDevice
                ,&c_dfDIKeyboard);
            if (pdxcContext->hLastResult==DI_OK)
            {
                pdxcContext->hLastResult = IDirectInputDevice_SetCooperativeLevel(pdxcContext->lpDIKeyboardDevice,
                    pdxcContext->hwndMain, DISCL_FOREGROUND | DISCL_NONEXCLUSIVE);
                if (pdxcContext->hLastResult==DI_OK)
                {
                    pdxcContext->hLastResult = IDirectInputDevice_Acquire(pdxcContext->lpDIKeyboardDevice);
                    if (pdxcContext->hLastResult==DI_OK)
                        bReturn=TRUE;
                }
            }
        }
    }
    if (!bReturn)
        DI_ERROR
    return bReturn;
}

BOOL DX_PollKeyboard(DX_CONTEXT *pdxcContext)
{
    pdxcContext->hLastResult = IDirectInputDevice_GetDeviceState(pdxcContext->lpDIKeyboardDevice,
    sizeof(keyArray),(LPVOID)&keyArray);
    if (pdxcContext->hLastResult==DIERR_INPUTLOST)
        pdxcContext->hLastResult = IDirectInputDevice_Acquire(pdxcContext->lpDIKeyboardDevice);
    if (SUCCEEDED(pdxcContext->hLastResult))
        return TRUE;
    DI_ERROR
    return FALSE;
}

BOOL DX_KeyDown(DX_CONTEXT *pdxcContext, int iKey)
{
    return (keyArray[iKey]&0xF0?TRUE:FALSE);
}

